#define _CRT_SECURE_NO_WARNINGS

using namespace std;

#include <string>
#include <vector>
#include <deque>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <algorithm>
#include <stack>
#include <random>

//
#ifdef _DEBUG
#include <fstream>
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif // _DEBUG

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

const ll INF = 1e18;
const ll mod = 1e9 + 7;
const ll reverse_2 = 500000004;
const int magic_const = 1e9;
const int MAX_N = 1e5 + 5;
const ld EPS = 1e-9;
const ld PI = 3.14159265358979323;

template<typename T>
void output_vector(vector<T>& vect)
{
	for (auto& i : vect)
		cout << i << " ";

	cout << endl;
}

template<typename T>
void output_matrix(vector<vector<T>>& matrix)
{
	for (int i = 0; i < matrix.size(); i++)
	{
		for (int j = 0; j < matrix[i].size(); j++)
		{
			cout << matrix[i][j] << " ";
		}
		cout << "\n";
	}
}

void output_number_in_binary(int num_t, int length)
{
	for (int j = length - 1; j >= 0; j--)
	{
		if (num_t & (1 << j))
			cout << "1";
		else
			cout << "0";
	}
	cout << "\n";
}

ll gcd(ll x, ll y)
{
	return (y == 0) ? x : gcd(y, x % y);
}

class dsu
{
private:
	vector<int>parents;
	vector<int> sizes;

public:
	dsu(int n) : parents(n), sizes(n, 1)
	{
		for (int i = 0; i < n; i++)
		{
			parents[i] = i;
		}
	}

	int get_parent(int x)
	{
		return parents[x] == x ? x : parents[x] = get_parent(parents[x]);
	}

	void unite(int x, int y)
	{
		int parent_1 = get_parent(x);
		int parent_2 = get_parent(y);
		if (parent_1 == parent_2)
			return;
		if (sizes[parent_1] < sizes[parent_2])
			swap(parent_1, parent_2);

		sizes[parent_1] += sizes[parent_2];
		parents[parent_2] = parent_1;
	}
};

template<typename T>
void sort(vector<T>& vect)
{
	sort(vect.begin(), vect.end());
}

template<typename T>
void reverse(vector<T>& vect)
{
	reverse(vect.begin(), vect.end());
}

template<typename T>
void unique(vector<T>& vect, bool need_sort = true)
{
	if (need_sort)
		sort(vect);

	vect.resize(unique(vect.begin(), vect.end()) - vect.begin());
}

template<typename T>
void set_max(T& first, T second)
{
	first = max(first, second);
}

template<typename T>
void set_min(T& first, T second)
{
	first = min(first, second);
}

#if (!((defined(_MSVC_LANG) && _MSVC_LANG >= 201703L) || __cplusplus >= 201703L))
template<class T>
constexpr const T& clamp(const T& v, const T& lo, const T& hi)
{
	return (v < lo) ? lo : (hi < v) ? hi : v;
}
#endif

int count_ans(vector<string>& st, int left_x, int left_y, int right_x, int right_y)
{
	int answer = 0;
	bool exist_land = false;
	for (int i = left_x; i <= right_x; i++)
	{
		for (int j = left_y; j <= right_y; j++)
		{
			if (st[i][j] == '.')
				answer++;
		}
	}
	return answer;
}


class fenwick_tree
{
	vector<int>sum;

public:
	fenwick_tree(int n)
	{
		sum.resize(n + 5, 0);
	}

	int get_sum(int pos)
	{
		int answer = 0;
		for (pos++; pos > 0; pos -= pos & -pos)
			answer += sum[pos];
		return answer;
	}

	void add_value(int pos, int delta)
	{
		for (pos++; pos < sum.size(); pos += pos & -pos)
			sum[pos] += delta;
	}

	int get_answer(int l, int r)
	{
		return get_sum(r) - get_sum(l - 1);
	}
};

int get_delta(char c)
{
	if (c == '(')
		return 1;
	else
		return -1;
}

void solve(int __test_num)
{
	int n;
	cin >> n;

	string s;
	cin >> s;

	vector<int>vf(n + 2, -1);
	int balance = 0;
	for (int i = 0; i < n; i++)
	{
		balance += get_delta(s[i]);
		if (balance < 0)
		{
			if (vf[i] != -1)
			{
				vf[i + 1] = vf[i];
			}
			else
			{
				vf[i + 1] = i;
			}
		}
	}
	if (balance != 0)
	{
		cout << -1;
		return;
	}

	int answer = 0;
	for (int i = 1; i <= n; i++)
	{
		if (vf[i] != -1 && vf[i + 1] == -1)
		{
			answer += i - vf[i] + 1;
		}
	}

	cout << answer << endl;
}

void init_input()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(323122328);
}

int main()
{
	init_input();

	//test();

	int t = 1;
	//cin >> t;

	for (int test_num = 1; test_num <= t; test_num++)
	{
		//cout << "Case #" << i << ": ";
		solve(test_num);
	}
}
//Special comment for fucking ejudge
